// ViewerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "math.h"
#include "Viewer.h"
#include "ViewerDlg.h"
#include "c:\project\blast3d\blast3d.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

btfparticle * myparticle;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewerDlg dialog

CViewerDlg::CViewerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CViewerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CViewerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CViewerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewerDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CViewerDlg, CDialog)
	ON_WM_QUERYNEWPALETTE()
	ON_WM_PALETTECHANGED()
	ON_WM_CREATE()
	//{{AFX_MSG_MAP(CViewerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_WM_CLOSE()
	ON_COMMAND(ID_PHONG, OnPhong)
	ON_COMMAND(ID_SMOOTH, OnSmooth)
	ON_UPDATE_COMMAND_UI(ID_PHONG, OnUpdatePhong)
	ON_UPDATE_COMMAND_UI(ID_SMOOTH, OnUpdateSmooth)
	ON_COMMAND(ID_DITH8, OnDith8)
	ON_COMMAND(ID_TRUE24, OnTrue24)
	ON_UPDATE_COMMAND_UI(ID_TRUE24, OnUpdateTrue24)
	ON_UPDATE_COMMAND_UI(ID_DITH8, OnUpdateDith8)
	ON_WM_SHOWWINDOW()
	ON_WM_DRAWITEM()
	ON_COMMAND(ID_Normal, OnNormal)
	ON_COMMAND(ID_Surface, OnSurface)
	ON_COMMAND(ID_Lorenz, OnLorenz)
	ON_COMMAND(ID_ImageMap, OnImageMap)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewerDlg message handlers

BOOL CViewerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
    	
	// TODO: Add extra initialization here
	clickflag=0;
	angx=0;
	angy=0;
	angz=0;
	vtx=0;
	vty=0;
	vtz=-20;
    curmode=0;
    curready=FALSE;
	curformat=1;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CViewerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CViewerDlg::OnPaint() 
{
	if(curformat==0 && curready==TRUE)
		{
		int currentdc;
		CPaintDC dc(this);
		currentdc=(int)dc.m_hDC;
		::RealizeColors256(currentdc);
	    ::RenderAll(currentdc);
	    }
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
	
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CViewerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CViewerDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
    CClientDC dc(this);
	CRect rect;
	int currentdc;
    btfvertex sweepvertex[7];
    char testfile[2000]="c:\\project\\viewer\\tes.b3d";
    BYTE * texturetest;

	fx=-3;

	if(curformat==0)
		{
		int currentdc;
		CPaintDC dc(this);
		currentdc=(int)dc.m_hDC;
		::RealizeColors256(currentdc);
		}
    

    sweepvertex[0].x = 0;
	sweepvertex[0].y = .5 ;
	sweepvertex[0].z = 0;
    
	sweepvertex[1].x = .3;
	sweepvertex[1].y = .2;
	sweepvertex[1].z = 0;
    
	sweepvertex[2].x = .7;
	sweepvertex[2].y = -0.5;
	sweepvertex[2].z = 0;
    
	sweepvertex[3].x = 0.9;
	sweepvertex[3].y = 0.3;//-0.1;
	sweepvertex[3].z = 0;
    
	sweepvertex[4].x = 0.4;
	sweepvertex[4].y = -0.3;
	sweepvertex[4].z = 0;
    
	sweepvertex[5].x = 0.2;
	sweepvertex[5].y = -1.9;
	sweepvertex[5].z = 0;

	sweepvertex[6].x = 0;
	sweepvertex[6].y = -2.2;
	sweepvertex[6].z = 0;

	vtz=-520;

if(curready==TRUE)
{
	if(clickflag==0)
	{
	 //create frame buffer
     clickflag++;
	 GetClientRect(&rect);
	 currentdc=(int)dc.m_hDC;
	 //::inibufferCPP(currentdc,1,(int)(rect.Width()),(int)(rect.Height()));
	 ::setrendermode(curmode);
	 ::createlookupCPP();
	 
	 //Create the objects
     ::CreateSweep(RGB(255, 126, 27), 1, &sweepvertex[0], 7);
	 //::CreateCone(RGB(0, 0, 255), 1);
	 //::CreateCylinder(RGB(255, 0, 255), 1);
	 //::CreateSphere(RGB(255,0,0),1);
     //::CreateCube(RGB(25, 127, 76), 0);

	 //test saving
	 //::SaveScenetoDisk(testfile);
     //::cleanup();     
	 //::ReadScenefromDisk(testfile);

     //set light source
	 ::setlightCPP(20,60,-220);
   
 	   if(curformat==0)
		{
		::RealizeColors256(currentdc);
		}
	 ::RenderAll(currentdc);

    //do texture-mapping test
     ::CreateTexture(currentdc,310,190,"c:\\windows\\viewtest.bmp",TRUE);
     ::CreateTexture(currentdc,310,190,"c:\\windows\\viewtest2.bmp",TRUE);
	 if(Map_Type!=3)
	 {
	 ::MapTexturetoObject(0,1,1,0,1.2,1.2);
	 }
	 else
	 {
	 ::MapTexturetoObject(0,0,3,0,1.2,1.2);
	 }
	 //::MapTexturetoObject(3,0,3,0,1.2,1.2);
    
	//do particle systems test
	if(particle_type==0)
	{
	 myparticle=::CreateParticleSystem2("c:\\windows\\partest.bmp",currentdc);
	::UpdateParticle2(myparticle);
    ::SetParticleColor(255,255,255,10,10,10);	
    }
	else
	{
	 myparticle=::CreateParticleSystem();
	::UpdateParticle(myparticle);
    ::SetParticleColor(0,255,255,0,0,255);	
	::CreateFog(0,30,100);
	}
	BeginWaitCursor();
	for(int k=0;k<1000;k++)
	{
 	
	if(particle_type==0)
	{
	::ApplyForce2(myparticle,0,.5,0);
    ::UpdateParticle2(myparticle);
	}
	else
	{
	::ApplyForce(myparticle,0,.5,0);
    ::UpdateParticle(myparticle);
	}

	}
    EndWaitCursor();
	do
	{
	 
     angx = angx - 5;
     angy = angy + 3.5;
     angz = angz + 2;
    
	 if(angx > 360)
	 {
	  angx = angx - 360;
	 }
     if(angx < 0)
	 {
      angx = 360 + angx;
	 }
     
	 if(angy > 360)
	 {
	  angy = angy - 360;
	 }
     if(angy < 0)
	 {
      angy = 360 + angy;
	 }

	 if(angz > 360)
	 {
	  angz = angz - 360;
	 }
     if(angz < 0)
	 {
      angz = 360 + angz;
	 }

     ::SelectObj(0);
	 ::inittransCPP();
	 ::scaleobjCPP(90, 130, 90);
	 ::rotateCPP(angx, angy, angz);
     ::translateCPP(0,  - 20, 150);
	 ::ApplyTransform();
	 /*
	 ::SelectObj(1);
	 ::inittransCPP();
	 ::scaleobjCPP(40, 40, 40);
	 ::rotateCPP(angy, angz, angz);
     ::translateCPP(-200,   100, 150);
     ::ApplyTransform();
	 
	 ::SelectObj(2);
	 ::inittransCPP();
	 ::scaleobjCPP(50, 50, 50);
	 ::rotateCPP(angy, angz, angx);
     ::translateCPP(190,   70, 180);
     ::ApplyTransform();
	 
	 ::SelectObj(3);
	 ::inittransCPP();
	 ::scaleobjCPP(50, 50, 50);
	 ::rotateCPP(angx, angy, angz);
     ::translateCPP(190,   -150, 180);
     ::ApplyTransform();

     ::SelectObj(4);
	 ::inittransCPP();
	 ::scaleobjCPP(50,50,50);
	 ::rotateCPP(angy, angy, angz);
     ::translateCPP(-220,   -150, 240);
     ::ApplyTransform();
    */
	 //transform particles
     if(particle_type==0)
	 {
	 ::ApplyForce2(myparticle,0,.5,.3);
	 ::UpdateParticle2(myparticle);
	 ::inittransCPP();
	 ::scaleobjCPP(190,190,90);
	 ::rotateCPP(angx, angy, angz);
	 //::rotateCPP(0,0,0);
     //::translateCPP(-220,   -50, 240);
	 ::translateCPP(0,  40, 150);
	 }
	 else
	 {
	 ::ApplyForce(myparticle,0,.5,0);
	 ::UpdateParticle(myparticle);
	 ::inittransCPP();
	 ::scaleobjCPP(3,10,10);
	 ::translateCPP(-30,  0, 20);
	 ::rotateCPP(angx, angy, angz);
	 //::rotateCPP(0,0,0);
     //::translateCPP(-220,   -50, 240);
	 ::translateCPP(25,  10, 150);
	 }
	 ::TransformParticle(myparticle);
	 fx=fx+.01;
	 //done
     vtz++;
	 if(vtz>-120)
	 {
	 vtz=-120;
	 }
	 ::setTHEviewer(0,0,vtz,0,0,0);
	 ::SetParticleView(myparticle);
	  //if(curformat==0)
		//{
		//::RealizeColors256(currentdc);
		//}
     //::RenderAll(currentdc);
     ::RenderObjects();
     if(particle_type==0)
	 {
	 ::RenderParticle2(myparticle);
	 }
	 else
	 {
	 ::RenderParticle(myparticle);
	 }
	 ::CopytoScreen(currentdc);

	 if(!PeekAndPump())
		 break;
	} while(clickflag<2);
	
	}
	else
	{
	 ::CleanupTextures();
	 ::deletebufferCPP();
	 ::cleanup();
	 ::DeleteParticleSystem(myparticle);
	 ::PostQuitMessage(0);
	}
}	
	CDialog::OnLButtonDown(nFlags, point);
}

void CViewerDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	 ::deletebufferCPP();
	 ::cleanup();
	 ::PostQuitMessage(0);
	
	CDialog::OnClose();
}

BOOL CViewerDlg::PeekAndPump()
{
 MSG msg;
 while(::PeekMessage(&msg,NULL,0,0,PM_NOREMOVE))
 {
  if(!AfxGetApp ()->PumpMessage ())
  {
   ::PostQuitMessage (0);
   return FALSE;
  
 }
 }

 long lidle = 0;
 while(AfxGetApp ()->OnIdle (lidle++));
 return TRUE;

}

void CViewerDlg::OnPhong() 
{
	// TODO: Add your command handler code here
   curmode=1;	
   ::setrendermode(curmode);
}

void CViewerDlg::OnSmooth() 
{
	// TODO: Add your command handler code here
	curmode=0;
    ::setrendermode(curmode);
}

void CViewerDlg::OnUpdatePhong(CCmdUI* pCmdUI)
{
	// TODO: Add your command handler code here
    
}

void CViewerDlg::OnUpdateSmooth(CCmdUI* pCmdUI)
{
	// TODO: Add your command handler code here
}



void CViewerDlg::OnDith8() 
{
	// TODO: Add your command handler code here
    CClientDC dc(this);
	CRect rect;
	
	int currentdc;
    if(curready==FALSE)
	{
	 GetClientRect(&rect);
	 currentdc=(int)dc.m_hDC;
	 ::deletebufferCPP();
	 ::cleanup();
	 ::inibufferCPP(currentdc,0,(int)(rect.Width()),(int)(rect.Height()));
     ::RealizeColors256(currentdc);	
	curready=TRUE;
	curformat=0;
	}
}

void CViewerDlg::OnTrue24() 
{
	// TODO: Add your command handler code here
	if(curready==FALSE)
	{
	CClientDC dc(this);
	CRect rect;
	int currentdc;
    
	 GetClientRect(&rect);
	 currentdc=(int)dc.m_hDC;
	 ::deletebufferCPP();
	 ::cleanup();
	 ::inibufferCPP(currentdc,1,(int)(rect.Width()),(int)(rect.Height()));
	curready=TRUE;
	curformat=1;
	}
}

void CViewerDlg::OnUpdateTrue24(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
}

void CViewerDlg::OnUpdateDith8(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CViewerDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
		if(curformat==0)
		{
		int currentdc;
		CPaintDC dc(this);
		currentdc=(int)dc.m_hDC;
		::RealizeColors256(currentdc);
		}

}

void CViewerDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	// TODO: Add your message handler code here and/or call default
		if(curformat==0)
		{
		int currentdc;
		CPaintDC dc(this);
		currentdc=(int)dc.m_hDC;
		::RealizeColors256(currentdc);
		}

	CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);
}

BOOL CViewerDlg::OnQueryNewPalette()
{
	// CG: This function was added by the Palette Support component

	//if (m_pPalette == NULL)
		return FALSE;
	
	// BLOCK
	//{
	//	CClientDC dc(this);
	//	CPalette* pOldPalette = dc.SelectPalette(m_pPalette,
	//		GetCurrentMessage()->message == WM_PALETTECHANGED);
	//	UINT nChanged = dc.RealizePalette();
	//	dc.SelectPalette(pOldPalette, TRUE);

	//	if (nChanged == 0)
	//		return FALSE;
	//}
	
	//Invalidate();
}

void CViewerDlg::OnPaletteChanged(CWnd* pFocusWnd)
{
	// CG: This function was added by the Palette Support component

	//if (pFocusWnd == this || IsChild(pFocusWnd))
		//return;
	//OnQueryNewPalette();
}

CPalette* CViewerDlg::SetPalette(CPalette* pPalette)
{
	// CG: This function was added by the Palette Support component

	// Call this function when the palette changes.  It will
	// realize the palette in the foreground to cause the screen
	// to repaint correctly.  All calls to CDC::SelectPalette in
	// painting code should select palettes in the background.

	CPalette* pOldPalette = m_pPalette;
	m_pPalette = pPalette;
	OnQueryNewPalette();
	return pOldPalette;
}

int CViewerDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	// CG: This function was added by the Palette Support component
//
//	if (CDialog::OnCreate(lpCreateStruct) == -1)
//		return -1;

//	m_pPalette = NULL;
	return 0;
}

void CViewerDlg::OnNormal() 
{
	// TODO: Add your command handler code here
	Map_Type=0;
    if(curready==TRUE)
	{
	 if(Map_Type!=3)
	 {
	 ::MapTexturetoObject(0,0,1,0,1.2,1.2);
	 }
	 else
	 {
	 ::MapTexturetoObject(0,0,3,0,1.2,1.2);
	 }
	
	}
}

void CViewerDlg::OnSurface() 
{
	// TODO: Add your command handler code here
	Map_Type=3;
    if(curready==TRUE)
	{
	 if(Map_Type!=3)
	 {
	 ::MapTexturetoObject(0,0,1,0,1.2,1.2);
	 }
	 else
	 {
	 ::MapTexturetoObject(0,0,3,0,1.2,1.2);
	 }
	
	}
}

void CViewerDlg::OnLorenz() 
{
	// TODO: Add your command handler code here
	particle_type=1;

}

void CViewerDlg::OnImageMap() 
{
	// TODO: Add your command handler code here
   particle_type=0;	
}
