// ViewerDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CViewerDlg dialog

class CViewerDlg : public CDialog
{
// Construction
public:
	int particle_type;
	int Map_Type;
	CViewerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CViewerDlg)
	enum { IDD = IDD_VIEWER_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CViewerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	afx_msg BOOL OnQueryNewPalette();
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	CPalette* SetPalette(CPalette* pPalette);
	CPalette* m_pPalette;
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	HICON m_hIcon;
    int clickflag;
	int angx,angy,angz;
	int vtx,vty,vtz;
	int vrx,vry,vrz;
	int curmode;
	int curformat;
	int curready;
	float fx;
	HPALETTE hpal;
	BOOL PeekAndPump();
	// Generated message map functions
	//{{AFX_MSG(CViewerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnClose();
	afx_msg void OnPhong();
	afx_msg void OnSmooth();
	afx_msg void OnUpdatePhong(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSmooth(CCmdUI* pCmdUI);
	afx_msg void OnDith8();
	afx_msg void OnTrue24();
	afx_msg void OnUpdateTrue24(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDith8(CCmdUI* pCmdUI);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	afx_msg void OnNormal();
	afx_msg void OnSurface();
	afx_msg void OnLorenz();
	afx_msg void OnImageMap();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

